import sys, random, time

# partition range a[lo:hi+1] and return index of pivot
def partition(a, lo, hi):
  p = (lo + hi)//2
  pivot = a[p]
  a[p] = a[hi]  # Swap pivot with last item
  a[hi] = pivot

  i = lo - 1
  j = hi
  while i < j: 
    i += 1 
    while a[i] < pivot: 
      i += 1
    j -= 1
    while a[j] > pivot and j > lo: 
      j -= 1
    if i < j:
      t = a[i]; a[i] = a[j]; a[j] = t  # swap a[i] and a[j]
  a[hi] = a[i]
  a[i] = pivot # Put pivot where it belongs
  return i     # index of pivot

# sort range a[lo:hi+1]
def quick_sort(a, lo, hi):
  if (lo < hi):
    pivotIndex = partition(a, lo, hi)
    quick_sort(a, lo, pivotIndex - 1)
    quick_sort(a, pivotIndex + 1, hi)

n = int(sys.argv[1])
w = [ random.randrange(1000000) for i in range(n) ]
print(w[:100])
startTime = time.time()
quick_sort(w, 0, len(w)-1)
stopTime = time.time()
print(w[:100])

print("Runtime %g secs" % (stopTime - startTime))
